within ;
package cv3
  model bb

    constant Real g = 10;
    //  parameter Real m = 1;
    Real s(start = 1);
    Real v;
  discrete Real a(start = -g);
  parameter Real c = 0.9 "utlum odrazu";
  equation
    v = der(s);
    a = der(v);
    when s < 0 then
      // v -> -v*c
      reinit(v, -v * c);
    end when;
    when s < (-1e-3) then
      reinit(s, 0);
      reinit(v, 0);
      //    a = 0;
    end when;
    //  assert(s > (-1e-3), "Propadli jsme podlahou! Koncim.");
  end bb;

  model balon

    pqcon pqcon1 annotation(Placement(visible = true, transformation(origin = {4, -80}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {4, -80}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  Real V;
  parameter Real iv = 1;
    Modelica.Blocks.Interfaces.RealInput c annotation (Placement(transformation(
            extent={{-96,58},{-56,98}}), iconTransformation(extent={{-96,58},{-56,
              98}})));
  initial equation
    V = iv;
  equation
    pqcon1.p = V * c;
    der(V) = pqcon1.q;
    annotation(Icon(graphics={  Ellipse(origin = {1, 1}, extent = {{-87, 77}, {87, -77}}, endAngle = 360)}), Diagram);
  end balon;

  connector pqcon
    Real p;
    flow Real q;
    annotation(Icon(graphics={  Rectangle(origin = {3, -4}, fillColor = {46, 79, 59},
              fillPattern =                                                                         FillPattern.Solid, extent = {{-89, 92}, {89, -92}})}), Diagram);
  end pqcon;

  model odpor
    pqcon pqcon1 annotation(Placement(visible = true, transformation(origin = {-92, -2}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-92, -2}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  pqcon pqcon2 annotation(Placement(visible = true, transformation(origin = {88, 2}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {88, 2}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  parameter Real R = 1;
  parameter Real L = 0;
  equation
    if L == 0 then
      pqcon1.p - pqcon2.p = R * pqcon1.q;
    else
      pqcon1.p - pqcon2.p = R * pqcon1.q + L * der(pqcon1.q);
    end if;
    pqcon1.q + pqcon2.q = 0;
    annotation(Icon(graphics={  Rectangle(origin = {-1, 0}, extent = {{-83, 22}, {83, -22}})}), Diagram(graphics = {Rectangle(origin=  {2, 11}, extent=  {{-92, 41}, {92, -41}})}));
  end odpor;

  model chlopen
    Real s;
    Real dp;
    Real q;
    Boolean open;
  pqcon pqcon1 annotation(Placement(visible = true, transformation(origin = {-88, -2}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-88, -2}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  pqcon pqcon2 annotation(Placement(visible = true, transformation(origin = {86, 2}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {86, 2}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  equation
    open = s > 0;
    if open then
      dp = 0;
      s = q;
    else
      dp = s;
      q = 0;
    end if;
    pqcon1.q + pqcon2.q = 0;
  pqcon1.q = q;
    pqcon1.p - pqcon2.p = dp;
    annotation(Icon(graphics={           Polygon(origin={2.00001,12.0936},     points = {{-68, 75.9064}, {-64, -84.0936}, {44, -6.09355}, {50, -82.0936}, {68, -82.0936}, {64, 83.9064}, {34, 81.9064}, {40, 5.90645}, {-68, 75.9064}})}));
  end chlopen;


  model p_src
    cv3.pqcon pqcon1 annotation(Placement(visible = true, transformation(origin = {0, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {2, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  parameter Real p;
  equation
    pqcon1.p = p;
    annotation(Icon(graphics={  Polygon(origin = {-1.02352, -11.9992}, points = {{-76.9765, 77.9992}, {59.0235, 77.9992}, {91.0235, -8.00083}, {55.0235, -78.0008}, {-48.9765, -72.0008}, {-90.9765, -0.000830029}, {-76.9765, 77.9992}})}), Diagram);
  end p_src;

  annotation(Icon, Diagram,
    uses(Modelica(version="3.2.1")));
  model system1

    p_src p_src1(p=1)
      annotation (Placement(transformation(extent={{-98,0},{-78,20}})));
    odpor odpor1
      annotation (Placement(transformation(extent={{-66,0},{-46,20}})));
    chlopen chlopen1
      annotation (Placement(transformation(extent={{-32,2},{-12,22}})));
    balon balon1 annotation (Placement(transformation(extent={{6,14},{26,34}})));
    chlopen chlopen2
      annotation (Placement(transformation(extent={{24,-4},{44,16}})));
    p_src p_src2(p=10)
      annotation (Placement(transformation(extent={{80,-2},{100,18}})));
    Modelica.Blocks.Sources.Sine sine(
      amplitude=1,
      freqHz=1,
      offset=1.1)
      annotation (Placement(transformation(extent={{-50,36},{-30,56}})));
    odpor odpor2
      annotation (Placement(transformation(extent={{54,-4},{74,16}})));
  equation
    connect(chlopen2.pqcon1, balon1.pqcon1) annotation (Line(points={{25.2,5.8},
            {16.4,5.8},{16.4,16}}, color={0,0,0}));
    connect(chlopen1.pqcon2, chlopen2.pqcon1) annotation (Line(points={{-13.4,
            12.2},{4,12.2},{4,5.8},{25.2,5.8}}, color={0,0,0}));
    connect(chlopen1.pqcon1, odpor1.pqcon2) annotation (Line(points={{-30.8,
            11.8},{-39.4,11.8},{-39.4,10.2},{-47.2,10.2}}, color={0,0,0}));
    connect(odpor1.pqcon1, p_src1.pqcon1) annotation (Line(points={{-65.2,9.8},
            {-87.8,9.8},{-87.8,10}}, color={0,0,0}));
    connect(sine.y, balon1.c) annotation (Line(points={{-29,46},{-12,46},{-12,
            34},{-12,31.8},{8.4,31.8}}, color={0,0,127}));
    connect(chlopen2.pqcon2, odpor2.pqcon1) annotation (Line(points={{42.6,6.2},
            {54.3,6.2},{54.3,5.8},{54.8,5.8}}, color={0,0,0}));
    connect(odpor2.pqcon2, p_src2.pqcon1) annotation (Line(points={{72.8,6.2},{
            90.2,6.2},{90.2,8}}, color={0,0,0}));
    annotation (Diagram(coordinateSystem(preserveAspectRatio=false, extent={{
              -100,-100},{100,100}})));
  end system1;
end cv3;
